﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Threading;
using System.IO;

namespace S55Kamera
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }
        string image_hex;
        int counter = 0;
        string incoming;
        UInt16 ack;
        Thread take;
        Thread init;

        private void Form1_Load(object sender, EventArgs e)
        {
            CheckForIllegalCrossThreadCalls = false;
        }

        private void converttoimgage(string image_data)
        {
            //Konvertiere String-Hex to Byte
            Byte[] imageData = new Byte[image_data.Length / 2];
            int f = 0;
            for (int i = 0; i < image_data.Length - 1; i = i + 2)
            {
                Byte byteBLOBData = (Byte)(int.Parse(image_data.Substring(i, 2), System.Globalization.NumberStyles.HexNumber));
                imageData[f] = byteBLOBData;
                f++;
            }

            //Bild erzeugen und anzeigen
            MemoryStream stmBLOBData = new MemoryStream(imageData);
            pictureBox1.Image = Image.FromStream(stmBLOBData);

            //Jpg Datei schreiben
            FileStream jpg = File.OpenWrite("image.jpg");
            stmBLOBData.WriteTo(jpg);
            jpg.Flush();
            jpg.Close();
        }
       
        //Init Prozess
        private void serialPort1_DataReceived(object sender, System.IO.Ports.SerialDataReceivedEventArgs e)
        {
            serialPort1.DataReceived -= new System.IO.Ports.SerialDataReceivedEventHandler(serialPort1_DataReceived);
            while (serialPort1.BytesToRead >= 1 && serialPort1.IsOpen == true)
            {
                incoming += Convert.ToChar(serialPort1.ReadChar());
                if (incoming.Contains("\r") == true)
                {
                    ack = 1;
                    //Auswerten der Antwort
                    if (incoming.Length >= 30 && incoming.Substring(0, 20) == "AT^SACD=2,\"17,04,2,2")
                    { //Größen der Bilder empfangen
                        kl_byte.Text = incoming.Substring(21, 4) + " byte";
                        gr_byte.Text = incoming.Substring(26, 5) + " byte";

                        progressBar1.Maximum = Convert.ToInt32(incoming.Substring(26, 5));
                    }
                    //Kamera bereit
                    if (incoming == "AT^SACD=2,\"17,04,2,3\"\r")
                    {
                        button4.Enabled = true;
                        button3.Enabled = false;
                    }
                    //Ausgabe in Textbox
                    incoming = incoming.Replace("\r", "\r\n");
                    textBox1.Text += incoming;
                    incoming = "";
                }

            }
            serialPort1.DataReceived += new System.IO.Ports.SerialDataReceivedEventHandler(serialPort1_DataReceived);
        }
        //Image Emfangen
        private void receive_image(object sender, System.IO.Ports.SerialDataReceivedEventArgs e)
        {
            serialPort1.DataReceived -= new System.IO.Ports.SerialDataReceivedEventHandler(receive_image);
            while (serialPort1.BytesToRead >= 1 && serialPort1.IsOpen == true)
            {
                string hex = serialPort1.ReadByte().ToString("x").ToUpper();
                if (hex.Length < 2)
                    hex = "0" + hex;
                image_hex += hex;
                counter++;
                progressBar1.Value = counter;
            }
            serialPort1.DataReceived += new System.IO.Ports.SerialDataReceivedEventHandler(receive_image);
            
            if (counter == progressBar1.Maximum)
                kamera_end();
        }

        private void kamera_init()
        {
            ack = 0;
            serialPort1.BaudRate = 19200;
            serialPort1.Write("OK" + Convert.ToChar(13));
            while (ack == 0) { }
            ack = 0;
            serialPort1.Write("OK" + Convert.ToChar(13));
            while (ack == 0) { }
            ack = 0;
            serialPort1.Write("OK" + Convert.ToChar(13));
            while (ack == 0) { }
            ack = 0;
            serialPort1.Write("OK" + Convert.ToChar(13));
            while (ack == 0) { }
            ack = 0;
            serialPort1.Write("OK" + Convert.ToChar(13));
            while (ack == 0) { }
            ack = 0;
            serialPort1.Write("OK" + Convert.ToChar(13));
            while (ack == 0) { }
            ack = 0;
            
        }
        private void kamera_take()
        {
            serialPort1.Write("OK" + Convert.ToChar(13));
            serialPort1.Write("^SACD: 17,04,2,1" + Convert.ToChar(13)); //Mache Foto
            //serialPort1.Write("^SACD: 17,03,2" + Convert.ToChar(13));
            while (ack == 0) { }
            ack = 0;
            serialPort1.Write("OK" + Convert.ToChar(13));
            while (ack == 0) { }
            ack = 0;
            serialPort1.Write("OK" + Convert.ToChar(13));
            while (ack == 0) { }
            ack = 0;
            serialPort1.Write("OK" + Convert.ToChar(13));
            serialPort1.Write("^SACD: 17,01,2,2" + Convert.ToChar(13)); //Foto anfordern
            while (ack == 0) { }
            ack = 0;
            serialPort1.Write("OK" + Convert.ToChar(13));
            System.Threading.Thread.Sleep(500);
            serialPort1.DataReceived -= new System.IO.Ports.SerialDataReceivedEventHandler(serialPort1_DataReceived);
            serialPort1.Close();
            serialPort1.BaudRate = 115200;
            serialPort1.Open();
            serialPort1.Write("CONNECT" + Convert.ToChar(13));
            image_hex = ""; //Letztes Bild leeren
            serialPort1.DataReceived += new System.IO.Ports.SerialDataReceivedEventHandler(receive_image);
            textBox1.Text += "CTS auf GND legen !\r\n";
        }

        private void kamera_end()
        {
            //Funktionen tauschen
            serialPort1.DataReceived -= new System.IO.Ports.SerialDataReceivedEventHandler(receive_image);
            serialPort1.DataReceived += new System.IO.Ports.SerialDataReceivedEventHandler(serialPort1_DataReceived);

            serialPort1.Write("OK" + Convert.ToChar(13));
            serialPort1.Close();
            serialPort1.BaudRate = 19200;
            serialPort1.Open();
            System.Threading.Thread.Sleep(200);
            serialPort1.Write("OK" + Convert.ToChar(13));
            System.Threading.Thread.Sleep(200);
            serialPort1.Write("^SACD: 17,02,2" + Convert.ToChar(13));
            while (ack == 0) { }
            ack = 0;
            serialPort1.Write("OK" + Convert.ToChar(13));
            while (ack == 0) { }
            ack = 0;
            serialPort1.Write("OK" + Convert.ToChar(13));
            while (ack == 0) { }
            ack = 0;
            take.Abort();                    
            converttoimgage(image_hex);
        }

        private void button3_Click(object sender, EventArgs e)
        {   //Button Initialisieren
            serialPort1.PortName = comboBox1.SelectedItem.ToString();
            serialPort1.Open();
            init = new Thread(kamera_init);
            init.Start();
        }
        private void button4_Click(object sender, EventArgs e)
        {   //Button Aufnahme
            init.Abort();
            progressBar1.Value = 0;
            counter = 0;
            take = new Thread(kamera_take);
            take.Start();
            button4.Enabled = false;
        }

        private void button1_Click_1(object sender, EventArgs e)
        {   //Button Beenden
            this.Close();
        }


    }
}
